package io.tswf.minecraft.blockventure.modloader.forge

import groovy.transform.CompileStatic
import io.tswf.minecraft.blockventure.core.block.entity.AutoBlockEntityType
import io.tswf.minecraft.blockventure.modloader.init.BlockVentureModLoader
import net.minecraftforge.common.MinecraftForge
import net.minecraftforge.eventbus.api.IEventBus
import net.minecraftforge.fml.common.Mod
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent
import net.minecraftforge.fml.javafmlmod.FMLJavaModLoadingContext

import java.util.function.Consumer

@Mod("blockventuremodloader")
@CompileStatic
class BlockVentureModLoaderForge {

    BlockVentureModLoaderForge() {
        // This is our mod's event bus, used for things like registry or lifecycle events
        IEventBus MOD_BUS = FMLJavaModLoadingContext.get().getModEventBus()

        // This listener is fired on both client and server during setup.
        MOD_BUS.addListener(new CommonSetupListener())
        // This listener is only fired during client setup, so we can use client-side methods here.
//        MOD_BUS.addListener(new ClientSetupListener())

        // Most other events are fired on Forge's bus.
        // If we want to use annotations to register event listeners,
        // we need to register our object like this!
        MinecraftForge.EVENT_BUS.register(this)
    }

    static class CommonSetupListener implements Consumer<FMLCommonSetupEvent> {

        @Override
        void accept(FMLCommonSetupEvent event) {
            AutoBlockEntityType.registerAutoBlockEntityType()
            BlockVentureModLoader.scanMods()
            BlockVentureModLoader.instanciateMods()
            BlockVentureModLoader.initModsCommonSetup()
            BlockVentureModLoader.completeModsInitialization()
        }
    }
}
